package recursion

interface TailCall<T> {

    fun isComplete() = false
    fun apply(): TailCall<T>
    fun result(): T = throw UnsupportedOperationException()

    operator fun invoke() = generateSequence(this) { it.apply() }
        .first { it.isComplete() }
        .result()
}
